#include "soaring.h"
#include "util.h"
#include "form.h"
#include <Pilot.h>	// all the system toolbox headers
#include <SerialMgr.h>
#include <MemoryMgr.h>
#include <SystemMgr.h>

UInt   serial_ref;

Boolean RxData()
{
	UInt32 numBytes = 0;			
	Err err;
	char  buffer[522];
 
	err = SerReceiveCheck(serial_ref, &numBytes);

	if (err) {
		SerClearErr(serial_ref);
		// clean out errors and check if there is still data left
		return true;
	}

	if (numBytes <= 0)
		return false;

	if (numBytes > 512)
		numBytes = 512;

	numBytes=SerReceive(serial_ref, &buffer[0], numBytes, 0, &err);
	if (err) {
		SerClearErr(serial_ref);					
		return false;
	}

	data.parser.parser_func(&buffer[0], numBytes);

	return true;
}

Boolean RxInit()
{

	SerSettingsType serial_settings;
	Err err;
	DWord value;

	if (SysLibFind("Serial Library", &serial_ref)) {
		ErrDisplay("Error trying to load the serial library");
		return true;
	}

	//Try to open the cradel port ($8000)

	if (SerOpen(serial_ref, 0, 4800)) {
		ErrDisplay("Could not open serial port");
		return true;
	}

	serial_settings.flags = serSettingsFlagStopBits1 | serSettingsFlagBitsPerChar8 ;
	serial_settings.baudRate=4800;
	serial_settings.ctsTimeout=0;

	if (SerSetSettings(serial_ref,&serial_settings)) {
		ErrDisplay("Err when setting serial port values");
		return true;
	}
  
	return false;
}

void RxClose()
{
	SerClearErr(serial_ref);	
	SerClose(serial_ref);
}

void TxData(char *data)
{
	Err error;
	error = SerSend10(serial_ref, data,StrLen(data));
	ErrNonFatalDisplayIf( (error!=0), "Failed to send data to GPS");
	SerClearErr(serial_ref);	
	SerSendWait(serial_ref, -1);	
}

