#ifndef SOARDB_H
#define SOARDB_H

/*****************************************************************************
 * defines for working with the databases
 *****************************************************************************/
#define DB_RW_MODE			dmModeReadWrite
#define DB_RO_MODE			dmModeReadOnly
#define DB_W_MODE				dmModeWrite

#define NO_RECORD		dmMaxRecordIndex

#define DB_OPEN_SUCCESS  0
#define DB_OPEN_FAIL    -1
#define DB_OPEN_CREATE   1

/*****************************************************************************
 * prototypes
 *****************************************************************************/
int OpenCreateDB(DmOpenRef *dbP, 
						UInt cardNo, 
						CharPtr name, 
						ULong dbcreator, 
						ULong type, 
						UInt mode);
short OpenDBCountRecords(DmOpenRef	openDBDB);
short OpenDBAddRecord(DmOpenRef		openDBDB,
						long		size,
						VoidPtr		openDBP,
						Boolean		atStart);
short OpenDBNewRecord(DmOpenRef		openDBDB,
						long		size,
						VoidHand	*openDBH,
						VoidPtr		*openDBP,
						Boolean		atStart);
Boolean OpenDBGetRecord(DmOpenRef	openDBDB,
						int			index,
						VoidHand	*openDBH,
						VoidPtr		*openDBP);
Boolean OpenDBQueryRecord(DmOpenRef	openDBDB,
						int			index,
						VoidHand	*openDBH,
						VoidPtr		*openDBP);
Boolean OpenDBReleaseRecord(DmOpenRef	openDBDB,
							int			index,
							VoidHand	*openDBH,
							VoidPtr		*openDBP,
							Boolean		save);
Boolean OpenDBDeleteRecord(DmOpenRef	openDBDB,
							int			index);
Boolean OpenDBEmpty(DmOpenRef	openDBDB);
void OpenDBSetBackup(DmOpenRef	openDBRef,
					Boolean		setForBackup);
Boolean OpenDBUpdateRecord(DmOpenRef openDBDB,
                  long  size,
                  VoidPtr  openDBP,
                  int   dbIndex);

#endif
